﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
  using System.Collections.Generic;
  using Base.Erc;
  using Common;
  using Stack;

  public interface IReadOnlyPushConfiguration : IDeepCloneable {
    IReadOnlyDictionary<StackTypes, bool> EnabledStacks { get; }
    int EvalPushLimit { get; }
    int MaxDepth { get; }
    int MaxStringLength { get; }
    int MaxVectorLength { get; }
    int MaxPointsInProgram { get; }
    int MaxPointsInRandomExpression { get; }
    bool TopLevelPushCode { get; }
    bool TopLevelPopCode { get; }
    int MaxParenthesesClose { get; }
    double ParenthesesCloseBiasLevel { get; }
    IReadOnlyErcOptions ErcOptions { get; }
    IReadOnlyList<string> EnabledExpressions { get; }
    string FloatStringFormat { get; }
  }
}
